program Land;

uses
  enZGLine,
  Windows,
  Messages,
  u_map;

var
  mode: TMode = (ResX         : 640;
                 ResY         : 480;
                 bpp          : 32;
                 full         : true;
                 Freq         : -1;
                 AntiAliasing : true;
                 Samples      : -1;
                 Anisotropy   : true;
                 v_sync       : false);

  ShowHelp: boolean = false;
  font: TGLFont;

  fog_color: array[0..3] of single = (0.5,0,1,1);

function IntToStr(n: integer): string;
begin
  Str(n,result);
end;

var
  ang: TVector3D;
  pos: TVector3D;
  b_i, b_j: integer;

procedure Update;
var
  p1, p2, p3, p4: TVector3D;
  i, j: integer;
  w1, w2, w3, w4: single;
  wa: single;
begin
  if inp.KeyDown(VK_ESCAPE) then eng.Quit;

  if inp.KeyDown(ord('W')) then cam.StepForward (1);
  if inp.KeyDown(ord('S')) then cam.StepBackward(1);
  if inp.KeyDown(ord('A')) then cam.StepLeft    (1);
  if inp.KeyDown(ord('D')) then cam.StepRight   (1);
  cam.Rot(math3D.NewVector3D(-0.5*inp.MouseDelta.Y,-0.5*inp.MouseDelta.X,0));
  ang := cam.GetAngle;
  if ang.x >  90 then ang.x :=  90;
  if ang.x < -90 then ang.x := -90;
  cam.Ang(ang);
//  if ang.y >  90 then ang.x :=  90;
//  if ang.y < -90 then ang.x := -90;
//  if ang.z >  90 then ang.x :=  90;
//  if ang.z < -90 then ang.x := -90;
  pos := cam.GetPos;
  b_i := round(pos.x/5);
  b_j := round(pos.z/5);
  if  (b_i >= 0)
  and (b_i < 513)
  and (b_j >= 0)
  and (b_j < 513)
  then
  begin
    pos.y := round(150*bData[b_i,b_j]/255) + 15;
    cam.Move(pos);
  end;

{  i := Trunc(pos.x/5);
  j := Trunc(pos.z/5);
  if  (i >= 0)
  and (i <= 511)
  and (j >= 0)
  and (j <= 511)
  then
  begin}
{    p1 := math3D.NewVector3D(i*5  ,bData[i  ,j  ]*2.55,j*5  );
    p2 := math3D.NewVector3D(i*5+5,bData[i+1,j  ]*2.55,j*5  );
    p3 := math3D.NewVector3D(i*5  ,bData[i  ,j+1]*2.55,j*5+5);
    p4 := math3D.NewVector3D(i*5+5,bData[i+1,j+1]*2.55,j*5+5);
    w1 := math3D.V_Abs(math3D.V_Sub(pos,p1));
    w2 := math3D.V_Abs(math3D.V_Sub(pos,p2));
    w3 := math3D.V_Abs(math3D.V_Sub(pos,p3));
    w4 := math3D.V_Abs(math3D.V_Sub(pos,p4));
    wa := sqrt(w1*w1+w2*w2+w3*w3+w4*w4);
    if wa = 0 then wa := 1;
    w1 := w1/wa;
    w2 := w2/wa;
    w3 := w3/wa;
    w4 := w4/wa;
    pos.y := w1*p1.y + w2*p2.y + w3*p3.y + w4*p4.y;}
//    pos.y := bData[i,j]*2.55;
{    cam.Move(pos);
  end;}
  cam.Update;
end;

function BoolToStr(b: boolean): string;
begin
  if b
    then result := 'True'
    else result := 'False';
end;

function FloatToStr(f: single): string;
begin
  Str(f:4:0,result);
end;

procedure Render;
begin
  ogl.Clear(true,true);
  cam.SetProj(90,1.333333333333333,0.1,500.0);
//  ogl.Translate(0,3,0);
//  ogl.Rotate(45,0,1,0);
  if Fog then
    ogl.EnableFog(fog_color[0],fog_color[1],fog_color[2],fog_color[3],0.05,100,500,FOG_LINEAR);

  if AntiAlias then ogl.AntiAliasing(true);
  tex.FilterGroup(Filter,MAP_GROUP);
  if wire then ogl.RenderMode(POLY_WIRE) else ogl.RenderMode(POLY_FILL);

  map.Render;

  if AntiAlias then ogl.AntiAliasing(false);

  if Fog then
    ogl.DisableFog;
  ogl.Set2D(800,600);
  ogl.SetColor(1,1,1,1);
  ogl.glTextOut('FPS              : '+IntToStr(eng.FPS),20,20,font);
  ogl.glTextOut('Chunks visible   : '+IntToStr(map.Chunks_vis),20,35,font);
  ogl.glTextOut('Triangles visible: '+IntToStr(map.Chunks_vis*2048),20,50,font);
  if not ShowHelp then
  begin
    ogl.glTextOut('F1: Show debug',20,65,font);
  end
  else
  begin
    ogl.glTextOut('F1: Hide debug',20,65,font);
    case filter of
      TF_NONE       : ogl.glTextOut('1: Filter = None',20,80,font);
      TF_BILINEAR   : ogl.glTextOut('1: Filter = Bilinear',20,80,font);
      TF_TRILINEAR  : ogl.glTextOut('1: Filter = Trilinear',20,80,font);
      TF_ANISOTROPY : ogl.glTextOut('1: Filter = Anisotropy',20,80,font);
    end;
    if AntiAlias
      then ogl.glTextOut('2: AntiAliasing 4x',20,95,font)
      else ogl.glTextOut('2: AntiAliasing None',20,95,font);
    ogl.glTextOut('3: Culling = '+BoolToStr(Cull),20,110,font);
    ogl.glTextOut('4: Wire    = '+BoolToStr(Wire),20,125,font);
    ogl.glTextOut('5: Detail  = '+BoolToStr(Detail),20,140,font);
    ogl.glTextOut('6: Fog     = '+BoolToStr(Fog),20,155,font);
  end;
  ogl.Swap;
end;

procedure Init;
begin
  fsys.AddPacksDir('Data');
  map.Init;
  inp.CursorHide;
  inp.LockMouse;
  cam.Init(math3D.NewVector3D(100,15,100),math3D.NewVector3D(0,135,0));
  ogl.ClearColor(fog_color[0],fog_color[1],fog_color[2],fog_color[3]);
  font := ogl.FontCreate('Terminal',12,12);
end;

procedure Free;
begin

end;

procedure msg(m: uint; w, l: integer);
begin
  case m of
    WM_KEYUP:
      case w of
        Ord('1'): filter    := (filter+1) mod 4;
        Ord('2'): AntiAlias := not AntiAlias;
        Ord('3'): Cull      := not Cull;
        Ord('4'): Wire      := not Wire;
        Ord('5'): Detail    := not Detail;
        Ord('6'): Fog       := not Fog;
        VK_F1   : ShowHelp  := not ShowHelp;
      end;
  end;
end;

var
  WinDir: array[0..127] of char;

begin
  InitENZGLINE;//(mode);

  GetWindowsDirectory(WinDir,127);  
  oal.PlayMusic(PAnsiChar(WinDir+'\system32\oobe\images\title.wma'),true);
  fsys.AddPacksDir('Data');

  eng.SetProc(PROC_INIT  ,@Init);
  eng.SetProc(PROC_FREE  ,@Free);
  eng.SetProc(PROC_UPDATE,@Update);
  eng.SetProc(PROC_RENDER,@Render);
  eng.SetProc(PROC_MSG   ,@msg);

  eng.Loop(50);
end.
